part of '../lib.dart';

class _RefSubscriptionUnit<T, K> extends Unit<T, K> {
  final Ref<T> ref;

  _RefSubscriptionUnit(this.ref);

  @override
  T unwrap() {
    return ref.value;
  }

  @override
  void init(CTNode node, K dep) {
    super.init(node, dep);
    ref._dependencies.add(owner);
  }

  @override
  void dispose() {
    super.dispose();
    ref._dependencies.remove(owner);
  }
}
